#ifndef IUNKNOWN_IMPL
#define IUNKNOWN_IMPL
#include "GestionnaireDeVerrou.h"
#include <unknwn.h>
class IUnknownImpl
   : public IUnknown
{
   unsigned long cptref_;
public:
   IUnknownImpl()
      : cptref_(1)
   {
      GestionnaireDeVerrou::get().incrementer();
   }
   virtual ~IUnknownImpl() throw()
      { GestionnaireDeVerrou::get().decrementer(); }
   unsigned long __stdcall AddRef()
      { return ++cptref_; }
   unsigned long __stdcall Release()
   {
      if (--cptref_)
         return cptref_;
      delete this;
      return 0;
   }
};
#endif
