#define _WIN32_DCOM // assurer la prsence des dclarations propres  COM
#include "../../Commun/Commun/Somme_h.h" // dclaration de ISomme
#include "../../Commun/Commun/UUID_Fabriques.h" // UUID de la fabrique
#include "ChargeurCOM.h"
#include <iostream>
int main ()
{
   using std::cout;
   using std::endl;
   ChargeurCOM chcom((ChargeurCOM::MultiThreaded()));
   const int NBITF_VOULUES = 1,
             ITF_ISOMME    = 0;
   MULTI_QI ItfDemandees[NBITF_VOULUES] = { { &IID_ISomme,  0, S_OK } };
   COSERVERINFO Serveur = { 0,  L"localhost", 0, 0 };
   HRESULT hr = CoCreateInstanceEx
                   (CLSID_FabriqueSommeExterne, // fabrique voulue
                    0, // != 0 seulement pour un agrgat
                    CLSCTX_SERVER, // contexte prfr de serveur
                    &Serveur, // le COSERVERINFO
                    NBITF_VOULUES, // nb. Elments du tableau ItfDemandees
                    ItfDemandees); // MULTI_QI[]
   if (SUCCEEDED(hr))
   {
      if (SUCCEEDED(ItfDemandees[ITF_ISOMME].hr))
      {
         ISomme *pSomme =
            static_cast<ISomme*>(ItfDemandees[ITF_ISOMME].pItf);
         int resultat;
         hr = pSomme->Somme(2, 3, &resultat);
         if (SUCCEEDED(hr))
            cout << "Somme de 2 et de 3 (via ISomme): " << resultat << endl;
         pSomme->Release();
      }
   }
}
