#ifndef COMSOMME_H
#define COMSOMME_H

#include "IUnknownImpl.h"
#include "ISommeImpl.h"

struct COMSomme
   : ISommeImpl, IUnknownImpl
{
   // Pour IUnknown
   unsigned long __stdcall AddRef()
      { return IUnknownImpl::AddRef(); }
   unsigned long __stdcall Release()
      { return IUnknownImpl::Release(); }
   HRESULT __stdcall QueryInterface(REFIID riid, void **ppv)
   {
      if (riid == IID_IUnknown)
         *ppv = static_cast<IUnknown*>
            (static_cast<IUnknownImpl*>(this));
      else if (riid == IID_ISomme)
         *ppv = static_cast<ISomme*>(this);
      else
      {
         *ppv = 0;
         return E_NOINTERFACE;
      }
      AddRef();
      return S_OK;
   }
};

#endif
