#ifndef GESTIONNAIRE_DE_VERROU_H
#define GESTIONNAIRE_DE_VERROU_H

#include "Mutex.h" // Mutex, Autoverrou
#include "Evenement.h" // Mutex, Autoverrou
#include "Incopiable.h"

class GestionnaireDeVerrou
   : Incopiable
{
   static GestionnaireDeVerrou singleton;
   GestionnaireDeVerrou() throw();
   unsigned long cptobj_;
   Mutex mutex_;
   Evenement fin_;
public:
   static GestionnaireDeVerrou &get() throw()
      { return singleton; }
   void incrementer() throw();
   void decrementer()throw();
   bool est_vide() const throw();
   void attendre_fin() const volatile throw()
      { fin_.attendre(); }
  ~GestionnaireDeVerrou() throw()
      { }
};

#endif
