#ifndef ICLASSFACTORY_IMPL
#define ICLASSFACTORY_IMPL

#include <unknwn.h>
#include "GestionnaireDeVerrou.h"

class IClassFactoryImpl
   : public IClassFactory
{
   unsigned long cptref_;
public:
   IClassFactoryImpl()
      : cptref_(1)
   {
   }
   unsigned long __stdcall AddRef()
      { return ++cptref_; }
   unsigned long __stdcall Release()
   {
      if (--cptref_)
         return cptref_;
      delete this;
      return 0;
   }
   HRESULT __stdcall LockServer(BOOL verrou)
   {
      if (verrou)
         GestionnaireDeVerrou::get().incrementer();
      else
         GestionnaireDeVerrou::get().decrementer();
      return S_OK;
   }
};

#endif
